Subject: Re: [Linux-zigbee-devel] [PATCH 4/4] ieee802154: remove seq member of mac_cb

From: Phoebe Buckheister <[email-masked]>
Date: Mon, 3 Mar 2014 15:12:19 +0100

> On a fragmented packet 6lowpan calls dev_hard_header once, then many
> times lowpan_fragment_xmit, depending on the number of fragments which
> is needed.

To me, the obvious answer would be "just don't do that". Each fragment
is a distinct packet, so it should not reuse a header that was created
for another packet in the first place.

> Each call of lowpan_fragment_xmit will have the same DSN value. Maybe
> we should put the increment of DSN in "mac802154/tx.c" before calling
> xmit callback from driver (Just an idea). What do you think about
> that?

That would work. Crypto will have to set it's own frame counter there
anyway, since reordering in the wpan queue would otherwise cause
unexpected packet drops. I don't see that need for the DSN though.